<id>
Collapsable YaBB Front End - More board + category options compatible
</id>

<version>
1.5 MBC + Cell Hover
</version>

<mod info>
Allows board members to collapse the board index to show only those categorys that they are interested in.

Settings for each member are stored in a .cat file in your /Members directory. Hence this mod does not modify any existing YaBB variable or member files.

This version is compatible with MORE BOARD + CATEGORY OPTIONS (by cae), except ensure that cae's mod is installed prior to this one.  Also compatible with Cell Hover

Upload modified files to their respective places,
Upload plus.gif and minus.gif into your YaBBImages folder.

History:
--------
1.5 - Scaredwitless'es version of a YaBB 1.3.1 updated.  Also added Plus and Minus icons that mimic a file tree structure.
1.3 B+C OPTS - .cat files are now deleted (oops!)

1.2 B+C OPTS - added icon showing if there are new posts in a category - only displays when cat is collapsed
1.2 B+C OPTS - categories defualt to expanded when .cat file is modified

1.1 B+C OPTS - No conflict error will occur during install when this mod is installed after the 'more board + category options' mod by cae.

1.1 - Removed code that upgrades old .cat files
</mod info>

<author>
snYpir (morpj97@hn.ozemail.com.au). Updated by scaredwitless
</author>

<homepage>
http://www.ntev.net
</homepage>

<edit file>
Sources\BoardIndex.pl
</edit file>

<search for>
        <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>
</search for>

<replace>
~;
	### snYpir's collapsable YaBB part 1
	# expand/collapse all buttons
	if ( $username ne 'Guest' ){
		$yymain .= qq~
		<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2">
		<table>
		<tr>
		<td>
		<font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>
		</td>
		<td>
		<font class="text1" color="$color{'titletext'}" size="2"><b>  </b></font><a href=$scripturl?action=collapse_all;status=1><font size=2 class="text1" color="$color{'titletext'}"><b>$exptxt{'1'}</b></font></a></td>
		</td>
		<td>
		<font class="text1" color="$color{'titletext'}" size="2"><b>  </b></font><a href=$scripturl?action=collapse_all;status=0><font size=2 class="text1" color="$color{'titletext'}"><b>$exptxt{'2'}</b></font></a><font class="text1" color="$color{'titletext'}" size="2"><b>  </b></font></td>
		</td>
		</tr>
		</table>
		</td>~;
	}
	else{
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>~;
	}
	### end snYpir's collapsable YaBB part 1
$yymain .= qq~
</replace>

<search for>
	foreach $curcat (@categories) {
		unless( $openmemgr{$curcat} ) { next; }
</search for>

<add before>
	### snYpir's collapsable YaBB part 2
	# init catstatus counter
	my $catcount=0;
	if ( $username ne 'Guest' ){
		# load the .cat file for this user, put into array
		fopen(FILE, "$memberdir/$username.cat");
		@catstatus = <FILE>;
		fclose(FILE);

		# remove trailing newline chars
		for( $_ = 0; $_ < @catstatus; $_++ ) { chomp $catstatus[$_]; }

		# .cat file for this user not found, or number of categories changed?
		if ( @catstatus ne @categories ){
			# write new .cat file for user
			fopen( FILE, ">$memberdir/$username.cat", 1);
			for( $_ = 0; $_ < @categories; $_++ ) {
				print FILE "0\n";
			}
			fclose(FILE);
			fopen(FILE, "$memberdir/$username.cat");
			@catstatus = <FILE>;
			fclose(FILE);
			for( $_ = 0; $_ < @catstatus; $_++ ) { chomp $catstatus[$_]; }
		}
	}
	### end snYpir's collapsable YaBB part 2
</add before>

<search for>
        <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> $catpic{$curcat}<font size="2"><b>$catname{$curcat}</b></font></a></td>
</search for>

<replace>
	~;
	### snYpir's collapsable YaBB part 3
	if ( $username ne 'Guest' ) {
		my $newmsg = 0;
		my $new = "";
		# determine if there are new posts somewhere in this category, but only if cat is collapsed
		if ( !$catstatus[$catcount] ) {
			foreach $curboard (@{$catboards{$curcat}}) {
				chomp $curboard;
				my $dlp = &getlog($curboard);
				if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {
					$newmsg = 1; last;
				}
			}
			if ( $newmsg ) { $new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~; }
			else { $new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~; }
		}
		if( $catstatus[$catcount] ) {
			$expandpic = qq~<img src="$imagesdir/minus.gif" border="0">~;}
		else {
			$expandpic = qq~<img src="$imagesdir/plus.gif" border="0">~;}
		$yymain .= qq~<td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18" onMouseOver="this.style.backgroundColor='$hover{'cellhover'}'; this.style.cursor='hand';" onMouseOut="this.style.backgroundColor='$color{'windowbg1'}';" onclick="window.location.href='$scripturl?action=collapse_cat;forumnum=$catcount'"><a name="$curcat"> $catpic{$curcat}<font size=2>$expandpic $new $caticon<a href=$scripturl?action=collapse_cat;forumnum=$catcount><b>$catname{$curcat}</b></a> </font></td>~;
	}
	else {
		$yymain .= qq~<td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> $catpic{$curcat}<font size=2>&#171; $caticon<b>$catname{$curcat}</b></a> &#187;</font></td>~;
	}
	### end snYpir's collapsable YaBB part 3
	$yymain .= qq~
</replace>

<search for>
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			my $access = &AccessCheck($curboard, '');
</search for>

<add before>
	### snYpir's collapsable YaBB part 4
	# if category is open, display boards (or if this user is a guest)
	if( $catstatus[$catcount] || $username eq 'Guest' ){
	### end snYpir's collapsable YaBB part 4
</add before>

<search for>
	}
	my $checkadded = 0;
</search for>

<add before>
	### snYpir's collapsable YaBB part 5
	}
	++$catcount;
	### end snYpir's collapsable YaBB part 5
</add before>

<search for>
sub MarkAllRead {
</search for>

<add before>
### snYpir's collapsable YaBB - subs
sub Collapse_Cat {
	my ($catindex,@catstatus);

	if ( $username eq 'Guest' ){
		&fatal_error($exptxt{'4'});
		exit;            
	}

	# Grab the index of the category to collapse/expand
	$catindex = $INFO{'forumnum'};

	# read the current users category file
	fopen(FILE, "$memberdir/$username.cat");
	@catstatus = <FILE>;
	fclose(FILE);
	chomp @catstatus;

	# does the file exist?
	if ( $catstatus[0] != 1 && $catstatus[0] != 0 ){
		&fatal_error($exptxt{'3'});
		exit;
	}

	# toggle the status of the selected category
	if ( $catstatus[$catindex] eq 1 ){
		$catstatus[$catindex] = 0;
	}
	else{
		$catstatus[$catindex] = 1;
	}

	# rewrite category file for this user
	fopen( FILE, ">$memberdir/$username.cat", 1);
	for( $_ = 0; $_ < @catstatus; $_++ ) { print FILE "$catstatus[$_]\n"; }
	fclose(FILE);

	&redirectinternal;
	exit;   
}

sub Collapse_All {
	my ($state,@catstatus);

	$state = $INFO{'status'};

	if ( $username eq 'Guest' ){
		&fatal_error($exptxt{'4'});
		exit;            
	}   

	# read the current users category file
	fopen(FILE, "$memberdir/$username.cat");
	my @catstatus = <FILE>;
	fclose(FILE);
	chomp @catstatus;   

	# does the file exist?
	if ( $catstatus[0] != 1 && $catstatus[0] != 0 ){
		&fatal_error($exptxt{'3'});
		exit;
	}   

	# rewrite category file for this user
	fopen( FILE, ">$memberdir/$username.cat", 1);
	for( $_ = 0; $_ < @catstatus; $_++ ) { print FILE "$state\n"; }
	fclose(FILE);   

	&redirectinternal;
	exit;  
}
### end snYpir's collapsable YaBB - subs

</add before>

<edit file>
english.lng
</edit file>

<search for>
1;
</search for>

<add before>
$exptxt{'1'} = "Expand";
$exptxt{'2'} = "Collapse";
$exptxt{'3'} = " User category file not found - please try refreshing the board index (back then F5).\n If you receive this message again, please inform an administrator.";
$exptxt{'4'} = " You must be a member to use the collapsable/collapsable categories!";


</add before>

<edit file>
Sources\SubList.pl
</edit file>

<search for>
'clean_log',"Admin.pl&clean_log",
</search for>

<add after>
'collapse_cat',"BoardIndex.pl&Collapse_Cat",
'collapse_all',"BoardIndex.pl&Collapse_All",
</add after>

<edit file>
Sources\Profile.pl
</edit file>

<search for>
			unlink("$memberdir/$member{'username'}.log");
</search for>

<add after>
			unlink("$memberdir/$member{'username'}.cat");
</add after>

<search for>
			unlink("$memberdir/$username.log");
</search for>

<add after>
			unlink("$memberdir/$username.cat");
</add after>

<edit file>
Sources\Admin.pl
</edit file>

<search for>
	unlink("$memberdir/$currentmem.log");
</search for>

<add after>
	unlink("$memberdir/$currentmem.cat");
</add after>